//
//  BT_BLE_Lib.h
//  BTBLEiOSFramework
//
//  Created by Powen Ko on 7/28/14.
//  Copyright (c) 2014 looptek. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreBluetooth/CoreBluetooth.h>


@protocol BT_BLE_LibDelegate;
@interface BT_BLE_Lib : NSObject< CBCentralManagerDelegate>
{
    NSObject<BT_BLE_LibDelegate> __weak *delegate;
    NSError *BTError;
}



@property (nonatomic, weak) id<BT_BLE_LibDelegate> __weak delegate;
- (void) UARTSend:(NSString*)message;
//- (bool) BlueToothConnect;
- (int) ConnectBlueTooth;
- (int)  BlueToothConnectStatus;
- (void) DigitalOuts:(NSString*)sender;
- (void) DigitalInput;
- (void)customFrameTestCase;
- (void)playTestMusic;


@end

@protocol BT_BLE_LibDelegate
- (void) BlueToothStatus:(NSString*)errorMsg;  // 取的HW 藍牙的連接情況
//- (void) UARTReciver:(NSString*)message;       // UART 收到資料
- (void) DidReceiveData:(NSString*)message;    // 收到資料
- (void) DidReadHardwareRevisionString:(NSString*)Msg;  // 硬體相關的訊息
- (void) DigitalInputPinsChanges:(NSString*)Msg;    // 數位輸入的情況改變
@end
